// CodeGear C++Builder
// Copyright (c) 1995, 2008 by CodeGear
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Zylcustomgpsreceiver.pas' rev: 20.00

#ifndef ZylcustomgpsreceiverHPP
#define ZylcustomgpsreceiverHPP

#pragma delphiheader begin
#pragma option push
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member functions
#pragma pack(push,8)
#include <System.hpp>	// Pascal unit
#include <Sysinit.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <Math.hpp>	// Pascal unit
#include <Sysutils.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <Graphics.hpp>	// Pascal unit
#include <Contnrs.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Dialogs.hpp>	// Pascal unit
#include <Dateutils.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Zylcustomgpsreceiver
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TCardinalPoint { cpNorth, cpSouth, cpEast, cpWest };
#pragma option pop

#pragma option push -b-
enum TDirection { dirForward, dirLeft, dirRight };
#pragma option pop

#pragma option push -b-
enum Zylcustomgpsreceiver__1 { GPAAM, GPBWC, GPGGA, GPGLL, GPMSS, GPRMB, GPRMC, GPGSA, GPGSV, GPVTG, GPZDA, GPWPL, GPRTE, GPXTE, AllNMEA };
#pragma option pop

typedef Set<Zylcustomgpsreceiver__1, GPAAM, AllNMEA>  TNMEACommands;

typedef void __fastcall (__closure *TSendReceiveEvent)(System::TObject* Sender, System::AnsiString Buffer);

typedef void __fastcall (__closure *TParamChangeEvent)(System::TObject* Sender, const System::Extended Value);

typedef void __fastcall (__closure *TPositionChangeEvent)(System::TObject* Sender, const int Degree, const int Minute, const System::Extended Second, const TCardinalPoint Direction);

typedef void __fastcall (__closure *TShortPositionChangeEvent)(System::TObject* Sender, const System::Extended Latitude, const System::Extended Longitude);

typedef void __fastcall (__closure *TShortPosition3DChangeEvent)(System::TObject* Sender, const System::Extended Latitude, const System::Extended Longitude, const System::Extended Altitude);

typedef void __fastcall (__closure *TCommandEvent)(System::TObject* Sender, const System::AnsiString Command);

class DELPHICLASS TReceiverStatus;
class PASCALIMPLEMENTATION TReceiverStatus : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	System::Extended FSignalStrength;
	System::Extended FSNR;
	System::Extended FFrequency;
	System::Extended FDataRate;
	
public:
	__fastcall TReceiverStatus(void);
	void __fastcall Reset(void);
	
__published:
	__property System::Extended SignalStrength = {read=FSignalStrength, write=FSignalStrength};
	__property System::Extended SNR = {read=FSNR, write=FSNR};
	__property System::Extended Frequency = {read=FFrequency, write=FFrequency};
	__property System::Extended DataRate = {read=FDataRate, write=FDataRate};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TReceiverStatus(void) { }
	
};


class DELPHICLASS TSatellite;
class PASCALIMPLEMENTATION TSatellite : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	int FPseudoRandomCode;
	int FAzimuth;
	int FElevation;
	int FSignalToNoiseRatio;
	void __fastcall SetAzimuth(const int Value);
	void __fastcall SetElevation(const int Value);
	void __fastcall SetSignalToNoiseRatio(const int Value);
	
public:
	__fastcall TSatellite(void);
	
__published:
	__property int PseudoRandomCode = {read=FPseudoRandomCode, write=FPseudoRandomCode, nodefault};
	__property int Azimuth = {read=FAzimuth, write=SetAzimuth, nodefault};
	__property int Elevation = {read=FElevation, write=SetElevation, nodefault};
	__property int SignalToNoiseRatio = {read=FSignalToNoiseRatio, write=SetSignalToNoiseRatio, nodefault};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TSatellite(void) { }
	
};


class DELPHICLASS TSatellites;
class PASCALIMPLEMENTATION TSatellites : public System::TObject
{
	typedef System::TObject inherited;
	
public:
	TSatellite* operator[](int Idx) { return Items[Idx]; }
	
private:
	Contnrs::TObjectList* fItems;
	TSatellite* __fastcall GetItem(int Idx);
	void __fastcall SetItem(int Idx, const TSatellite* Item);
	int __fastcall GetCount(void);
	
public:
	__property int Count = {read=GetCount, nodefault};
	__property TSatellite* Items[int Idx] = {read=GetItem, write=SetItem/*, default*/};
	__fastcall TSatellites(void);
	__fastcall virtual ~TSatellites(void);
	void __fastcall Add(const TSatellite* Item);
	void __fastcall Insert(int Idx, const TSatellite* Item);
	void __fastcall Delete(int Idx)/* overload */;
	void __fastcall DeleteById(const int SatelliteId)/* overload */;
	void __fastcall Clear(void);
	int __fastcall IndexOf(int SatelliteId);
	TSatellite* __fastcall GetById(int SatelliteId);
};


class DELPHICLASS TWayPoint;
class PASCALIMPLEMENTATION TWayPoint : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	System::AnsiString FName;
	int FLatDeg;
	int FLatMin;
	System::Extended FLatSec;
	TCardinalPoint FLatDir;
	TCardinalPoint FLongDir;
	int FLongDeg;
	int FLongMin;
	System::Extended FLongSec;
	void __fastcall SetLatDeg(const int Value);
	void __fastcall SetLatMin(const int Value);
	void __fastcall SetLatSec(const System::Extended Value);
	void __fastcall SetLatDir(const TCardinalPoint Value);
	void __fastcall SetLongDeg(const int Value);
	void __fastcall SetLongMin(const int Value);
	void __fastcall SetLongSec(const System::Extended Value);
	void __fastcall SetLongDir(const TCardinalPoint Value);
	
public:
	__property System::AnsiString Name = {read=FName, write=FName};
	__property int Latitude_Degree = {read=FLatDeg, write=SetLatDeg, nodefault};
	__property int Latitude_Minute = {read=FLatMin, write=SetLatMin, nodefault};
	__property System::Extended Latitude_Second = {read=FLatSec, write=SetLatSec};
	__property TCardinalPoint Latitude_Direction = {read=FLatDir, write=SetLatDir, nodefault};
	__property int Longitude_Degree = {read=FLongDeg, write=SetLongDeg, nodefault};
	__property int Longitude_Minute = {read=FLongMin, write=SetLongMin, nodefault};
	__property System::Extended Longitude_Second = {read=FLongSec, write=SetLongSec};
	__property TCardinalPoint Longitude_Direction = {read=FLongDir, write=SetLongDir, nodefault};
	__fastcall TWayPoint(void);
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TWayPoint(void) { }
	
};


class DELPHICLASS TWayPoints;
class PASCALIMPLEMENTATION TWayPoints : public System::TObject
{
	typedef System::TObject inherited;
	
public:
	TWayPoint* operator[](int Index) { return Items[Index]; }
	
private:
	Contnrs::TObjectList* fItems;
	TWayPoint* __fastcall GetItem(int Idx);
	void __fastcall SetItem(int Idx, const TWayPoint* Item);
	int __fastcall GetCount(void);
	
public:
	__property int Count = {read=GetCount, nodefault};
	__property TWayPoint* Items[int Index] = {read=GetItem, write=SetItem/*, default*/};
	__fastcall TWayPoints(void);
	__fastcall virtual ~TWayPoints(void);
	void __fastcall Add(const TWayPoint* Item);
	void __fastcall Insert(int Idx, const TWayPoint* Item);
	void __fastcall Delete(int Idx)/* overload */;
	void __fastcall Delete(const System::AnsiString WayPointName)/* overload */;
	void __fastcall Clear(void)/* overload */;
	int __fastcall IndexOf(const System::AnsiString WayPointName);
	TWayPoint* __fastcall GetByName(const System::AnsiString WayPointName);
};


class DELPHICLASS TRoute;
class PASCALIMPLEMENTATION TRoute : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	System::AnsiString FName;
	Classes::TStringList* FWayPoints;
	System::AnsiString __fastcall GetDestination();
	
public:
	__property System::AnsiString Name = {read=FName, write=FName};
	__property Classes::TStringList* WayPoints = {read=FWayPoints, write=FWayPoints};
	__property System::AnsiString Destination = {read=GetDestination};
	__fastcall TRoute(void);
	__fastcall virtual ~TRoute(void);
	System::AnsiString __fastcall WayPointListToStr();
};


class DELPHICLASS TNavigationInfo;
class PASCALIMPLEMENTATION TNavigationInfo : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	System::AnsiString FOrigin;
	System::AnsiString FDestination;
	System::Extended FRangeToDestination;
	System::Extended FTrueBearingToDestination;
	System::Extended FMagneticBearingToDestination;
	System::Extended FVelocityTowardsDestination;
	System::Extended FCrossTrackError;
	TDirection FDirectionToSteer;
	System::Extended FArrivalCircleRadius;
	
public:
	__fastcall TNavigationInfo(void);
	void __fastcall Reset(void);
	
__published:
	__property System::AnsiString Origin = {read=FOrigin, write=FOrigin};
	__property System::AnsiString Destination = {read=FDestination, write=FDestination};
	__property System::Extended RangeToDestination = {read=FRangeToDestination, write=FRangeToDestination};
	__property System::Extended TrueBearingToDestination = {read=FTrueBearingToDestination, write=FTrueBearingToDestination};
	__property System::Extended MagneticBearingToDestination = {read=FMagneticBearingToDestination, write=FMagneticBearingToDestination};
	__property System::Extended VelocityTowardsDestination = {read=FVelocityTowardsDestination, write=FVelocityTowardsDestination};
	__property System::Extended CrossTrackError = {read=FCrossTrackError, write=FCrossTrackError};
	__property TDirection DirectionToSteer = {read=FDirectionToSteer, write=FDirectionToSteer, nodefault};
	__property System::Extended ArrivalCircleRadius = {read=FArrivalCircleRadius, write=FArrivalCircleRadius};
public:
	/* TObject.Destroy */ inline __fastcall virtual ~TNavigationInfo(void) { }
	
};


typedef void __fastcall (__closure *TSatelliteReceiveEvent)(System::TObject* Sender, const TSatellite* Satellite);

typedef void __fastcall (__closure *TWayPointReceiveEvent)(System::TObject* Sender, const TWayPoint* WayPoint);

typedef void __fastcall (__closure *TArrivalEvent)(System::TObject* Sender, const TWayPoint* WayPoint, const bool IsCircleEntered, const bool IsPerpendicularPassed);

class DELPHICLASS TGPSPosition;
class PASCALIMPLEMENTATION TGPSPosition : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	System::Extended FLatitude;
	System::Extended FLongitude;
	int FLatitude_Degree;
	int FLatitude_Minute;
	System::Extended FLatitude_Second;
	TCardinalPoint FLatitude_Direction;
	int FLongitude_Degree;
	int FLongitude_Minute;
	System::Extended FLongitude_Second;
	TCardinalPoint FLongitude_Direction;
	System::Extended FAltitude;
	System::Extended FHeading;
	System::Extended FSpeed_Knots;
	System::Extended FSpeed_KMH;
	System::Extended FMagnetic_Variation;
	TCardinalPoint FMagnetic_Variation_Direction;
	System::Extended FMagnetic_Heading;
	System::Word FDay;
	System::Word FMonth;
	System::Word FYear;
	System::Word FHour;
	System::Word FMinute;
	System::Word FSecond;
	System::Word FMillisecond;
	System::Word FSatellite_Count;
	System::Extended FPDOP;
	System::Extended FHDOP;
	System::Extended FVDOP;
	System::Extended FGeo_Height;
	int FFix;
	int FMode1;
	int FMode2;
	TSatellites* FSatellites;
	void __fastcall SetLatDeg(const int Value);
	void __fastcall SetLatMin(const int Value);
	void __fastcall SetLatSec(const System::Extended Value);
	void __fastcall SetLatDir(const TCardinalPoint Value);
	void __fastcall SetLongDeg(const int Value);
	void __fastcall SetLongMin(const int Value);
	void __fastcall SetLongSec(const System::Extended Value);
	void __fastcall SetLongDir(const TCardinalPoint Value);
	void __fastcall SetHeading(const System::Extended Value);
	void __fastcall SetMagneticVariation(const System::Extended Value);
	void __fastcall SetMagnetic_Variation_Direction(const TCardinalPoint Value);
	void __fastcall SetMagneticHeading(const System::Extended Value);
	System::TDateTime __fastcall GetDateTime(void);
	void __fastcall SetDateTime(const System::TDateTime Value);
	void __fastcall SetHDOP(const System::Extended Value);
	void __fastcall SetVDOP(const System::Extended Value);
	void __fastcall SetPDOP(const System::Extended Value);
	
public:
	__fastcall TGPSPosition(void);
	void __fastcall Reset(void);
	__fastcall virtual ~TGPSPosition(void);
	
__published:
	__property int Latitude_Degree = {read=FLatitude_Degree, write=SetLatDeg, nodefault};
	__property int Latitude_Minute = {read=FLatitude_Minute, write=SetLatMin, nodefault};
	__property System::Extended Latitude_Second = {read=FLatitude_Second, write=SetLatSec};
	__property TCardinalPoint Latitude_Direction = {read=FLatitude_Direction, write=SetLatDir, nodefault};
	__property int Longitude_Degree = {read=FLongitude_Degree, write=SetLongDeg, nodefault};
	__property int Longitude_Minute = {read=FLongitude_Minute, write=SetLongMin, nodefault};
	__property System::Extended Longitude_Second = {read=FLongitude_Second, write=SetLongSec};
	__property TCardinalPoint Longitude_Direction = {read=FLongitude_Direction, write=SetLongDir, nodefault};
	__property System::Extended Altitude = {read=FAltitude, write=FAltitude};
	__property System::Extended Heading = {read=FHeading, write=SetHeading};
	__property System::Extended Speed_Knots = {read=FSpeed_Knots, write=FSpeed_Knots};
	__property System::Extended Speed_KMH = {read=FSpeed_KMH, write=FSpeed_KMH};
	__property System::Extended Magnetic_Variation = {read=FMagnetic_Variation, write=SetMagneticVariation};
	__property TCardinalPoint Magnetic_Variation_Direction = {read=FMagnetic_Variation_Direction, write=SetMagnetic_Variation_Direction, nodefault};
	__property System::Extended Magnetic_Heading = {read=FMagnetic_Heading, write=SetMagneticHeading};
	__property System::Word Day = {read=FDay, nodefault};
	__property System::Word Month = {read=FMonth, nodefault};
	__property System::Word Year = {read=FYear, nodefault};
	__property System::Word Hour = {read=FHour, nodefault};
	__property System::Word Minute = {read=FMinute, nodefault};
	__property System::Word Second = {read=FSecond, nodefault};
	__property System::Word Millisecond = {read=FMillisecond, nodefault};
	__property System::TDateTime DateTime = {read=GetDateTime, write=SetDateTime};
	__property System::Word Satellite_Count = {read=FSatellite_Count, write=FSatellite_Count, nodefault};
	__property System::Extended PDOP = {read=FPDOP, write=SetPDOP};
	__property System::Extended HDOP = {read=FHDOP, write=SetHDOP};
	__property System::Extended VDOP = {read=FVDOP, write=SetVDOP};
	__property System::Extended Geo_Height = {read=FGeo_Height, write=FGeo_Height};
	__property int Fix = {read=FFix, write=FFix, nodefault};
	__property int Mode1 = {read=FMode1, write=FMode1, nodefault};
	__property int Mode2 = {read=FMode2, write=FMode2, nodefault};
	__property TSatellites* Satellites = {read=FSatellites, write=FSatellites};
};


class DELPHICLASS TZylCustomGPSReceiver;
class PASCALIMPLEMENTATION TZylCustomGPSReceiver : public Classes::TComponent
{
	typedef Classes::TComponent inherited;
	
private:
	bool FRegistered;
	TGPSPosition* FPosition;
	System::AnsiString FData;
	System::AnsiString FDelayedData;
	TReceiverStatus* FReceiverStatus;
	TNavigationInfo* FNavigationInfo;
	bool FForceCheckSum;
	bool FNMEALog;
	bool FLogDateTime;
	System::UnicodeString FLogFile;
	TNMEACommands FCommands;
	TWayPoints* FWayPoints;
	TRoute* FActiveRoute;
	double FVersion;
	TSendReceiveEvent FOnReceive;
	TSendReceiveEvent FOnSend;
	TPositionChangeEvent FOnLatitudeChange;
	TPositionChangeEvent FOnLongitudeChange;
	TParamChangeEvent FOnAltitudeChange;
	TParamChangeEvent FOnSpeedChange;
	TParamChangeEvent FOnHeadingChange;
	TShortPositionChangeEvent FOn2DPositionChange;
	TShortPosition3DChangeEvent FOn3DPositionChange;
	TSatelliteReceiveEvent FOnSatelliteReceive;
	Classes::TNotifyEvent FOnSatellitesReceive;
	TArrivalEvent FOnArrival;
	TCommandEvent FOnUnknownCommand;
	TCommandEvent FOnNewCommand;
	TWayPointReceiveEvent FOnWayPointReceive;
	Classes::TNotifyEvent FOnActiveRouteReceive;
	bool __fastcall IsValidCommand(const System::AnsiString strNMEA);
	Classes::TStringList* __fastcall ExtractCommands(const System::AnsiString strNMEA);
	void __fastcall ExtractPosition(const System::AnsiString strNMEA);
	bool __fastcall ExtractCoord(System::AnsiString strLt, System::Word &lDegree, System::Word &lMinute, System::Extended &lSecond);
	bool __fastcall ExtractUTCTime(const System::AnsiString strUTC, System::Word &uHour, System::Word &uMinute, System::Word &uSecond, System::Word &uMSecond);
	bool __fastcall ExtractUTCDate(const System::AnsiString strDate, System::Word &dYear, System::Word &dMonth, System::Word &dDay);
	void __fastcall ParseNMEA(const System::AnsiString strNMEA);
	void __fastcall WriteLog(const System::UnicodeString str);
	System::Extended __fastcall FloatMod(System::Extended y, System::Extended x);
	System::AnsiString __fastcall ReplaceDecimalSeparator(const System::AnsiString s);
	System::AnsiString __fastcall SafeCopy(const System::AnsiString strText, int nStart, int nLength, const System::AnsiString DefaultValue);
	bool __fastcall CompareFloats(System::Extended Value1, System::Extended Value2);
	int __fastcall CommasCount(const System::AnsiString str);
	System::AnsiString __fastcall MaxLenStr(const System::AnsiString s, int MaxLen, char c);
	bool __fastcall RunningInTheIDE(void);
	void __fastcall DoRegistrationCheck(void);
	
protected:
	__property bool ForceCheckSum = {read=FForceCheckSum, write=FForceCheckSum, default=1};
	__property bool NMEALog = {read=FNMEALog, write=FNMEALog, default=0};
	__property bool LogDateTime = {read=FLogDateTime, write=FLogDateTime, default=0};
	__property System::UnicodeString LogFile = {read=FLogFile, write=FLogFile};
	__property TNMEACommands Commands = {read=FCommands, write=FCommands, nodefault};
	__property TSendReceiveEvent OnReceive = {read=FOnReceive, write=FOnReceive};
	__property TSendReceiveEvent OnSend = {read=FOnSend, write=FOnSend};
	__property TPositionChangeEvent OnLatitudeChange = {read=FOnLatitudeChange, write=FOnLatitudeChange};
	__property TPositionChangeEvent OnLongitudeChange = {read=FOnLongitudeChange, write=FOnLongitudeChange};
	__property TParamChangeEvent OnAltitudeChange = {read=FOnAltitudeChange, write=FOnAltitudeChange};
	__property TParamChangeEvent OnSpeedChange = {read=FOnSpeedChange, write=FOnSpeedChange};
	__property TParamChangeEvent OnHeadingChange = {read=FOnHeadingChange, write=FOnHeadingChange};
	__property TShortPositionChangeEvent OnPosition2DChange = {read=FOn2DPositionChange, write=FOn2DPositionChange};
	__property TShortPosition3DChangeEvent OnPosition3DChange = {read=FOn3DPositionChange, write=FOn3DPositionChange};
	__property TSatelliteReceiveEvent OnSatelliteReceive = {read=FOnSatelliteReceive, write=FOnSatelliteReceive};
	__property Classes::TNotifyEvent OnSatellitesReceive = {read=FOnSatellitesReceive, write=FOnSatellitesReceive};
	__property TArrivalEvent OnArrival = {read=FOnArrival, write=FOnArrival};
	__property TCommandEvent OnNewCommand = {read=FOnNewCommand, write=FOnNewCommand};
	__property TCommandEvent OnUnknownCommand = {read=FOnUnknownCommand, write=FOnUnknownCommand};
	__property TWayPointReceiveEvent OnWayPointReceive = {read=FOnWayPointReceive, write=FOnWayPointReceive};
	__property Classes::TNotifyEvent OnActiveRouteReceive = {read=FOnActiveRouteReceive, write=FOnActiveRouteReceive};
	System::AnsiString __fastcall WayPointToNMEA(const TWayPoint* WayPoint);
	System::AnsiString __fastcall RouteToNMEA(const TRoute* Route);
	
public:
	__property TWayPoints* WayPoints = {read=FWayPoints};
	__property TRoute* ActiveRoute = {read=FActiveRoute};
	__property double Version = {read=FVersion};
	__fastcall virtual TZylCustomGPSReceiver(Classes::TComponent* AOwner);
	__fastcall virtual ~TZylCustomGPSReceiver(void);
	int __fastcall GetNMEACheckSum(const System::AnsiString strNMEA);
	System::AnsiString __fastcall GetNMEACheckSumStr(const System::AnsiString strNMEA);
	bool __fastcall IsCheckSumOk(const System::AnsiString strNMEA);
	System::AnsiString __fastcall AddCheckSumToNMEA(const System::AnsiString strNMEA);
	System::AnsiString __fastcall AddCrLfToNMEA(const System::AnsiString strNMEA);
	void __fastcall FeedGPSReceiver(const System::AnsiString strNMEA);
	void __fastcall ClearWayPoints(void);
	void __fastcall ResetActiveRoute(void);
	void __fastcall ResetPosition(void);
	void __fastcall ResetNavigationInfo(void);
	void __fastcall ResetReceiverStatus(void);
	TGPSPosition* __fastcall GetPosition(void);
	System::Extended __fastcall GetLatitudeAsDecimalDegrees(void);
	System::Extended __fastcall GetLongitudeAsDecimalDegrees(void);
	System::Extended __fastcall GetLatitudeAsRadians(void);
	System::Extended __fastcall GetLongitudeAsRadians(void);
	System::Extended __fastcall GetLatitudeAsDM(void);
	System::Extended __fastcall GetLongitudeAsDM(void);
	void __fastcall GetLatitudeParams(int &Degree, int &Minute, System::Extended &Second, TCardinalPoint &Direction);
	void __fastcall GetLongitudeParams(int &Degree, int &Minute, System::Extended &Second, TCardinalPoint &Direction);
	int __fastcall GetLatitudeDegree(void);
	int __fastcall GetLatitudeMinute(void);
	System::Extended __fastcall GetLatitudeSecond(void);
	TCardinalPoint __fastcall GetLatitudeDirection(void);
	int __fastcall GetLongitudeDegree(void);
	int __fastcall GetLongitudeMinute(void);
	System::Extended __fastcall GetLongitudeSecond(void);
	TCardinalPoint __fastcall GetLongitudeDirection(void);
	int __fastcall GetSatelliteCount(void);
	TSatellites* __fastcall GetSatellites(void);
	System::Extended __fastcall GetAltitude(void);
	System::Extended __fastcall GetSpeed_KMH(void);
	System::Extended __fastcall GetSpeed_Knots(void);
	System::Extended __fastcall GetHeading(void);
	System::TDateTime __fastcall GetUTCDateTime(void);
	System::TDateTime __fastcall GetLocalDateTime(void);
	System::Extended __fastcall GetMagnetic_Variation(void);
	System::Extended __fastcall GetMagnetic_Heading(void);
	System::Extended __fastcall GetPDOP(void);
	System::Extended __fastcall GetHDOP(void);
	System::Extended __fastcall GetVDOP(void);
	System::Extended __fastcall GetGeo_Height(void);
	System::AnsiString __fastcall GetRawData();
	int __fastcall IsFix(void);
	int __fastcall GetMode1(void);
	int __fastcall GetMode2(void);
	TReceiverStatus* __fastcall GetReceiverStatus(void);
	TNavigationInfo* __fastcall GetNavigationInfo(void);
	System::Extended __fastcall KmhToKnots(System::Extended pSpeed);
	System::Extended __fastcall KnotsToKmh(System::Extended pSpeed);
	System::Extended __fastcall KmToMiles(System::Extended pDist);
	System::Extended __fastcall MilesToKm(System::Extended pDist);
	System::Extended __fastcall MetersToFeet(System::Extended pDist);
	System::Extended __fastcall FeetToMeters(System::Extended pDist);
	System::Extended __fastcall NauticalMilesToKm(System::Extended pDist);
	System::Extended __fastcall KmToNauticalMiles(System::Extended pDist);
	void __fastcall DMToDMS(int dmDegree, System::Extended dmMinute, int &Degree, int &Minute, System::Extended &Second);
	void __fastcall DMSToDM(int dmsDegree, int dmsMinute, System::Extended dmsSecond, int &Degree, System::Extended &Minute);
	System::Extended __fastcall DMSToDecimalDegrees(int Degree, int Minute, System::Extended Second, TCardinalPoint Direction);
	System::Extended __fastcall DMSToRadians(int Degree, int Minute, System::Extended Second, TCardinalPoint Direction);
	System::Extended __fastcall DecimalDegreesToRadians(System::Extended Degree);
	System::Extended __fastcall RadiansToDecimalDegrees(System::Extended Radian);
	void __fastcall LatitudeDecimalDegreesToDMS(System::Extended DecDegree, int &Degree, int &Minute, System::Extended &Second, TCardinalPoint &Direction);
	void __fastcall LatitudeRadiansToDMS(System::Extended Radian, int &Degree, int &Minute, System::Extended &Second, TCardinalPoint &Direction);
	void __fastcall LongitudeDecimalDegreesToDMS(System::Extended DecDegree, int &Degree, int &Minute, System::Extended &Second, TCardinalPoint &Direction);
	void __fastcall LongitudeRadiansToDMS(System::Extended Radian, int &Degree, int &Minute, System::Extended &Second, TCardinalPoint &Direction);
	System::Extended __fastcall Distance_KM(int Latitude_Degree1, int Latitude_Minute1, System::Extended Latitude_Second1, TCardinalPoint Latitude_Direction1, int Longitude_Degree1, int Longitude_Minute1, System::Extended Longitude_Second1, TCardinalPoint Longitude_Direction1, int Latitude_Degree2, int Latitude_Minute2, System::Extended Latitude_Second2, TCardinalPoint Latitude_Direction2, int Longitude_Degree2, int Longitude_Minute2, System::Extended Longitude_Second2, TCardinalPoint Longitude_Direction2)/* overload */;
	System::Extended __fastcall Distance_KM(System::Extended Latitude1, System::Extended Longitude1, System::Extended Latitude2, System::Extended Longitude2)/* overload */;
	System::Extended __fastcall DistanceTo_KM(int Latitude_Degree, int Latitude_Minute, System::Extended Latitude_Second, TCardinalPoint Latitude_Direction, int Longitude_Degree, int Longitude_Minute, System::Extended Longitude_Second, TCardinalPoint Longitude_Direction)/* overload */;
	System::Extended __fastcall DistanceTo_KM(System::Extended Latitude, System::Extended Longitude)/* overload */;
	System::Extended __fastcall Distance_Miles(int Latitude_Degree1, int Latitude_Minute1, System::Extended Latitude_Second1, TCardinalPoint Latitude_Direction1, int Longitude_Degree1, int Longitude_Minute1, System::Extended Longitude_Second1, TCardinalPoint Longitude_Direction1, int Latitude_Degree2, int Latitude_Minute2, System::Extended Latitude_Second2, TCardinalPoint Latitude_Direction2, int Longitude_Degree2, int Longitude_Minute2, System::Extended Longitude_Second2, TCardinalPoint Longitude_Direction2)/* overload */;
	System::Extended __fastcall Distance_Miles(System::Extended Latitude1, System::Extended Longitude1, System::Extended Latitude2, System::Extended Longitude2)/* overload */;
	System::Extended __fastcall DistanceTo_Miles(int Latitude_Degree, int Latitude_Minute, System::Extended Latitude_Second, TCardinalPoint Latitude_Direction, int Longitude_Degree, int Longitude_Minute, System::Extended Longitude_Second, TCardinalPoint Longitude_Direction)/* overload */;
	System::Extended __fastcall DistanceTo_Miles(System::Extended Latitude, System::Extended Longitude)/* overload */;
	System::Extended __fastcall Bearing(int Latitude_Degree1, int Latitude_Minute1, System::Extended Latitude_Second1, TCardinalPoint Latitude_Direction1, int Longitude_Degree1, int Longitude_Minute1, System::Extended Longitude_Second1, TCardinalPoint Longitude_Direction1, int Latitude_Degree2, int Latitude_Minute2, System::Extended Latitude_Second2, TCardinalPoint Latitude_Direction2, int Longitude_Degree2, int Longitude_Minute2, System::Extended Longitude_Second2, TCardinalPoint Longitude_Direction2)/* overload */;
	System::Extended __fastcall Bearing(System::Extended Latitude1, System::Extended Longitude1, System::Extended Latitude2, System::Extended Longitude2)/* overload */;
	System::Extended __fastcall BearingTo(int Latitude_Degree, int Latitude_Minute, System::Extended Latitude_Second, TCardinalPoint Latitude_Direction, int Longitude_Degree, int Longitude_Minute, System::Extended Longitude_Second, TCardinalPoint Longitude_Direction)/* overload */;
	System::Extended __fastcall BearingTo(System::Extended Latitude, System::Extended Longitude)/* overload */;
	void __fastcall DrawSatellites(Graphics::TCanvas* Canvas, int Radius, const Graphics::TColor BrushColor, const Graphics::TColor PenColor);
	void __fastcall DrawSky(Graphics::TCanvas* Canvas, int Radius, const Graphics::TColor BrushColor, const Graphics::TColor PenColor);
};


class DELPHICLASS EZylGPSReceiverException;
class PASCALIMPLEMENTATION EZylGPSReceiverException : public Sysutils::Exception
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ inline __fastcall EZylGPSReceiverException(const System::UnicodeString Msg) : Sysutils::Exception(Msg) { }
	/* Exception.CreateFmt */ inline __fastcall EZylGPSReceiverException(const System::UnicodeString Msg, System::TVarRec const *Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ inline __fastcall EZylGPSReceiverException(int Ident)/* overload */ : Sysutils::Exception(Ident) { }
	/* Exception.CreateResFmt */ inline __fastcall EZylGPSReceiverException(int Ident, System::TVarRec const *Args, const int Args_Size)/* overload */ : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ inline __fastcall EZylGPSReceiverException(const System::UnicodeString Msg, int AHelpContext) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ inline __fastcall EZylGPSReceiverException(const System::UnicodeString Msg, System::TVarRec const *Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext) { }
	/* Exception.CreateResHelp */ inline __fastcall EZylGPSReceiverException(int Ident, int AHelpContext)/* overload */ : Sysutils::Exception(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ inline __fastcall EZylGPSReceiverException(System::PResStringRec ResStringRec, System::TVarRec const *Args, const int Args_Size, int AHelpContext)/* overload */ : Sysutils::Exception(ResStringRec, Args, Args_Size, AHelpContext) { }
	/* Exception.Destroy */ inline __fastcall virtual ~EZylGPSReceiverException(void) { }
	
};


//-- var, const, procedure ---------------------------------------------------
#define RADIUS_EARTH  (6.378140E+03)

}	/* namespace Zylcustomgpsreceiver */
using namespace Zylcustomgpsreceiver;
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// ZylcustomgpsreceiverHPP
