unit Main;

{$IFDEF VER230}
  {$define DELPHI2009UP}
{$endif}

{$IFDEF VER220}
  {$define DELPHI2009UP}
{$endif}

{$IFDEF VER210}
  {$define DELPHI2009UP}
{$endif}

{$IFDEF VER200}
  {$define DELPHI2009UP}
{$endif}


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls,
  ZylCustomGPSReceiver, ZylUdpGPSReceiver;

type
  TfrmMain = class(TForm)
    btnStart: TButton;
    btnStop: TButton;
    memRaw: TMemo;
    GroupBox1: TGroupBox;
    efLatDeg: TEdit;
    Label1: TLabel;
    efLatMin: TEdit;
    Label2: TLabel;
    efLatSec: TEdit;
    Label3: TLabel;
    efLatDir: TEdit;
    Label4: TLabel;
    GroupBox2: TGroupBox;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    efLongDeg: TEdit;
    efLongMin: TEdit;
    efLongSec: TEdit;
    efLongDir: TEdit;
    GroupBox3: TGroupBox;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    efAlt: TEdit;
    efSpeed: TEdit;
    efHeading: TEdit;
    efSatCount: TEdit;
    Label13: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    lblUTCTime: TLabel;
    lblLocalTime: TLabel;
    PaintBox: TPaintBox;
    efPort: TEdit;
    Label14: TLabel;
    cmpZylGPSReceiver: TZylUdpGPSReceiver;
    procedure btnStartClick(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure cmpZylGPSReceiverSpeedChange(Sender: TObject; Value: Extended);
    procedure cmpZylGPSReceiverHeadingChange(Sender: TObject; Value: Extended);
    procedure cmpZylGPSReceiverConnect(Sender: TObject; Port: Integer);
    procedure cmpZylGPSReceiverDisconnect(Sender: TObject; Port: Integer);
    procedure cmpZylGPSReceiverAltitudeChange(Sender: TObject; Value: Extended);
    procedure cmpZylGPSReceiverLatitudeChange(Sender: TObject; Degree,
      Minute: Integer; Second: Extended; Direction: TCardinalPoint);
    procedure cmpZylGPSReceiverLongitudeChange(Sender: TObject; Degree,
      Minute: Integer; Second: Extended; Direction: TCardinalPoint);
    procedure cmpZylGPSReceiver2DPositionChange(Sender: TObject; Latitude,
      Longitude: Extended);
    procedure cmpZylGPSReceiver3DPositionChange(Sender: TObject; Latitude,
      Longitude, Altitude: Extended);
    procedure cmpZylGPSReceiverSatelliteReceive(Sender: TObject;
      Satellite: TSatellite);
    procedure PaintBoxPaint(Sender: TObject);
    procedure cmpZylGPSReceiverSatellitesReceive(Sender: TObject);
    {$ifdef DELPHI2009UP}
    procedure cmpZylGPSReceiverReceive(Sender: TObject; Buffer: AnsiString);
    {$else}
    procedure cmpZylGPSReceiverReceive(Sender: TObject; Buffer: String);
    {$endif}
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}

procedure TfrmMain.btnStartClick(Sender: TObject);
begin
  try
    cmpZylGPSReceiver.Port := StrToInt(efPort.Text);
    cmpZylGPSReceiver.Open;
  except
    MessageDlg('Invalid port.', mtError, [mbOK], 0);
  end;
end;

procedure TfrmMain.btnStopClick(Sender: TObject);
begin
  cmpZylGPSReceiver.Close;
end;

procedure TfrmMain.cmpZylGPSReceiverSpeedChange(Sender: TObject; Value: Extended);
begin
  memRaw.Lines.Add('Speed Changed:' + FloatToStr(Value) + ' KM/H');
end;

procedure TfrmMain.cmpZylGPSReceiverHeadingChange(Sender: TObject;
  Value: Extended);
begin
  memRaw.Lines.Add('Heading Changed:' + FloatToStr(Value) + ' Degrees');
end;

procedure TfrmMain.cmpZylGPSReceiverConnect(Sender: TObject; Port: Integer);
begin
  memRaw.Lines.Add('Connected to:' + IntToStr(cmpZylGPSReceiver.Port));
end;

procedure TfrmMain.cmpZylGPSReceiverDisconnect(Sender: TObject; Port: Integer);
begin
  memRaw.Lines.Add('Disconnected from:' + IntToStr(cmpZylGPSReceiver.Port));
end;

procedure TfrmMain.cmpZylGPSReceiverAltitudeChange(Sender: TObject;
  Value: Extended);
begin
  memRaw.Lines.Add('Altitude Changed:' + FloatToStr(Value) + ' M');
end;

procedure TfrmMain.cmpZylGPSReceiverLatitudeChange(Sender: TObject; Degree,
  Minute: Integer; Second: Extended; Direction: TCardinalPoint);
begin
  memRaw.Lines.Add('Latitude Changed: ' + FloatToStr(cmpZylGPSReceiver.DMSToDecimalDegrees(Degree, Minute, Second, Direction)));
end;

procedure TfrmMain.cmpZylGPSReceiverLongitudeChange(Sender: TObject; Degree,
  Minute: Integer; Second: Extended; Direction: TCardinalPoint);
begin
  memRaw.Lines.Add('Longitude Changed: ' + FloatToStr(cmpZylGPSReceiver.DMSToDecimalDegrees(Degree, Minute, Second, Direction)));
end;

procedure TfrmMain.cmpZylGPSReceiver2DPositionChange(Sender: TObject;
  Latitude, Longitude: Extended);
begin
  memRaw.Lines.Add('2D Position Changed. Distance to New York City = ' + FloatToStr(cmpZylGPSReceiver.Distance_Km(Latitude, Longitude, 40.77, 73.98)) + ' KM');
end;

procedure TfrmMain.cmpZylGPSReceiver3DPositionChange(Sender: TObject;
  Latitude, Longitude, Altitude: Extended);
begin
  memRaw.Lines.Add('3D Position Changed.');
end;

procedure TfrmMain.cmpZylGPSReceiverSatelliteReceive(Sender: TObject;
  Satellite: TSatellite);
var
  str: String;
begin
  str := 'Satellite Received' + ' Code=' + IntToStr(Satellite.PseudoRandomCode);
  str := str + ' Elevation=' + IntToStr(Satellite.Elevation);
  str := str + ' Azimuth=' + IntToStr(Satellite.Azimuth);
  str := str + ' Signal=' + IntToStr(Satellite.SignalToNoiseRatio);
  memRaw.Lines.Add(str);
end;

procedure TfrmMain.PaintBoxPaint(Sender: TObject);
begin
  cmpZylGPSReceiver.DrawSatellites(PaintBox.Canvas, PaintBox.Width div 2,
    clBlack, clWhite);
end;

procedure TfrmMain.cmpZylGPSReceiverSatellitesReceive(Sender: TObject);
begin
  PaintBox.Repaint;
end;

{$ifdef DELPHI2009UP}
procedure TfrmMain.cmpZylGPSReceiverReceive(Sender: TObject; Buffer: AnsiString);
{$else}
procedure TfrmMain.cmpZylGPSReceiverReceive(Sender: TObject;
  Buffer: String);
{$endif}
begin
  efLatDeg.Text := IntToStr(cmpZylGPSReceiver.GetLatitudeDegree);
  efLatMin.Text := IntToStr(cmpZylGPSReceiver.GetLatitudeMinute);
  efLatSec.Text := FloatToStr(cmpZylGPSReceiver.GetLatitudeSecond);
  if cmpZylGPSReceiver.GetLatitudeDirection = cpNorth then
    efLatDir.Text := 'North'
  else
    efLatDir.Text := 'South';

  efLongDeg.Text := IntToStr(cmpZylGPSReceiver.GetLongitudeDegree);
  efLongMin.Text := IntToStr(cmpZylGPSReceiver.GetLongitudeMinute);
  efLongSec.Text := FloatToStr(cmpZylGPSReceiver.GetLongitudeSecond);
  if cmpZylGPSReceiver.GetLongitudeDirection = cpEast then
    efLongDir.Text := 'East'
  else
    efLongDir.Text := 'West';

  efAlt.Text := FloatToStr(cmpZylGPSReceiver.GetAltitude);
  efSpeed.Text := FloatToStr(cmpZylGPSReceiver.GetSpeed_KMH);
  efHeading.Text := FloatToStr(cmpZylGPSReceiver.GetHeading);
  efSatCount.Text := IntToStr(cmpZylGPSReceiver.GetSatelliteCount);

  lblUTCTime.Caption := DateTimeToStr(cmpZylGPSReceiver.GetUTCDateTime);
  lblLocalTime.Caption := DateTimeToStr(cmpZylGPSReceiver.GetLocalDateTime);

  try
    memRaw.Lines.Add(Buffer);
    memRaw.Lines.Add('Fix = ' + IntToStr(cmpZylGPSReceiver.IsFix));
    //AssignFile(f, 'c:\gpsout.txt');
    //Append(f);
    //Write(f, ZylGPSReceiver.GetRawData);
    //CloseFile(f);
    memRaw.Lines.Add('---------------------------------------------------------')
  except
    memRaw.Lines.Clear;
  end;
end;

end.
